commit 4e77e4a7ec769d915a50c44e1635795a8673a634
Author: freddy77 <freddy77>
Date:   Tue Apr 13 13:19:12 2010 +0000

    improve CTLib cs_convert (partial patch from David Dick with additional tests)

diff --git a/ChangeLog b/ChangeLog
index 0281c23..3fb8a12 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Tue Apr 13 15:18:41 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/ctlib/cs.c src/ctlib/unittests/common.c:
+	* src/ctlib/unittests/t0006.c:
+	- improve CTLib cs_convert (partial patch from David Dick with
+	  additional tests)
+
 Sat Apr 10 16:29:29 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/tds/log.c:
 	- add TDS_LIKELY/TDS_UNLIKELY macro and use them for logging
@@ -2396,4 +2402,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3009 2010/04/10 14:29:36 freddy77 Exp $
+$Id: ChangeLog,v 1.3010 2010/04/13 13:19:12 freddy77 Exp $
diff --git a/src/ctlib/cs.c b/src/ctlib/cs.c
index d136fc3..14f126b 100644
--- a/src/ctlib/cs.c
+++ b/src/ctlib/cs.c
@@ -50,7 +50,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: cs.c,v 1.73 2009/06/09 08:55:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: cs.c,v 1.74 2010/04/13 13:19:12 freddy77 Exp $");
 
 static int _cs_datatype_length(int dtype);
 static CS_INT cs_diag_storemsg(CS_CONTEXT *context, CS_CLIENTMSG *message);
@@ -733,19 +733,17 @@ cs_convert(CS_CONTEXT * ctx, CS_DATAFMT * srcfmt, CS_VOID * srcdata, CS_DATAFMT
 	case SYBBINARY:
 	case SYBVARBINARY:
 	case SYBIMAGE:
-
+		ret = CS_SUCCEED;
 		if (len > destlen) {
-			free(cres.ib);
-			fprintf(stderr, "error_handler: Data-conversion resulted in overflow.\n");
+			tdsdump_log(TDS_DBG_FUNC, "error_handler: Data-conversion resulted in overflow\n");
 			ret = CS_FAIL;
-		} else {
-			memcpy(dest, cres.ib, len);
-			free(cres.ib);
-			for (i = len; i < destlen; i++)
-				dest[i] = '\0';
-			*resultlen = destlen;
-			ret = CS_SUCCEED;
+			len = destlen;
 		}
+		memcpy(dest, cres.ib, len);
+		free(cres.ib);
+		for (i = len; i < destlen; i++)
+			dest[i] = '\0';
+		*resultlen = destlen;
 		break;
 	case SYBBIT:
 	case SYBBITN:
@@ -812,54 +810,51 @@ cs_convert(CS_CONTEXT * ctx, CS_DATAFMT * srcfmt, CS_VOID * srcdata, CS_DATAFMT
 	case SYBCHAR:
 	case SYBVARCHAR:
 	case SYBTEXT:
+		ret = CS_SUCCEED;
 		if (len > destlen) {
-			fprintf(stderr, "error_handler: Data-conversion resulted in overflow.\n");
+			tdsdump_log(TDS_DBG_FUNC, "Data-conversion resulted in overflow\n");
+			len = destlen;
 			ret = CS_FAIL;
-		} else {
-			switch (destfmt->format) {
-
-			case CS_FMT_NULLTERM:
-				tdsdump_log(TDS_DBG_FUNC, "cs_convert() FMT_NULLTERM\n");
-				if (len == destlen) {
-					tdsdump_log(TDS_DBG_FUNC, "not enough room for data + a null terminator - error\n");
-					ret = CS_FAIL;	/* not enough room for data + a null terminator - error */
-				} else {
-					memcpy(dest, cres.c, len);
-					dest[len] = 0;
-					*resultlen = len + 1;
-					ret = CS_SUCCEED;
-				}
-				break;
-
-			case CS_FMT_PADBLANK:
-				tdsdump_log(TDS_DBG_FUNC, "cs_convert() FMT_PADBLANK\n");
-				/* strcpy here can lead to a small buffer overflow */
-				memcpy(dest, cres.c, len);
-				for (i = len; i < destlen; i++)
-					dest[i] = ' ';
-				*resultlen = destlen;
-				ret = CS_SUCCEED;
-				break;
+		}
+		switch (destfmt->format) {
 
-			case CS_FMT_PADNULL:
-				tdsdump_log(TDS_DBG_FUNC, "cs_convert() FMT_PADNULL\n");
-				/* strcpy here can lead to a small buffer overflow */
-				memcpy(dest, cres.c, len);
-				for (i = len; i < destlen; i++)
-					dest[i] = '\0';
-				*resultlen = destlen;
-				ret = CS_SUCCEED;
-				break;
-			case CS_FMT_UNUSED:
-				tdsdump_log(TDS_DBG_FUNC, "cs_convert() FMT_UNUSED\n");
+		case CS_FMT_NULLTERM:
+			tdsdump_log(TDS_DBG_FUNC, "cs_convert() FMT_NULLTERM\n");
+			if (len == destlen) {
+				tdsdump_log(TDS_DBG_FUNC, "not enough room for data + a null terminator - error\n");
+				ret = CS_FAIL;	/* not enough room for data + a null terminator - error */
+			} else {
 				memcpy(dest, cres.c, len);
-				*resultlen = len;
-				ret = CS_SUCCEED;
-				break;
-			default:
-				ret = CS_FAIL;
-				break;
+				dest[len] = 0;
+				*resultlen = len + 1;
 			}
+			break;
+
+		case CS_FMT_PADBLANK:
+			tdsdump_log(TDS_DBG_FUNC, "cs_convert() FMT_PADBLANK\n");
+			/* strcpy here can lead to a small buffer overflow */
+			memcpy(dest, cres.c, len);
+			for (i = len; i < destlen; i++)
+				dest[i] = ' ';
+			*resultlen = destlen;
+			break;
+
+		case CS_FMT_PADNULL:
+			tdsdump_log(TDS_DBG_FUNC, "cs_convert() FMT_PADNULL\n");
+			/* strcpy here can lead to a small buffer overflow */
+			memcpy(dest, cres.c, len);
+			for (i = len; i < destlen; i++)
+				dest[i] = '\0';
+			*resultlen = destlen;
+			break;
+		case CS_FMT_UNUSED:
+			tdsdump_log(TDS_DBG_FUNC, "cs_convert() FMT_UNUSED\n");
+			memcpy(dest, cres.c, len);
+			*resultlen = len;
+			break;
+		default:
+			ret = CS_FAIL;
+			break;
 		}
 		free(cres.c);
 		break;
diff --git a/src/ctlib/unittests/common.c b/src/ctlib/unittests/common.c
index b563131..a9f0c2a 100644
--- a/src/ctlib/unittests/common.c
+++ b/src/ctlib/unittests/common.c
@@ -22,9 +22,11 @@
 
 #include <ctpublic.h>
 #include "common.h"
+#ifdef TDS_STATIC_CAST
 #include "ctlib.h"
+#endif
 
-static char software_version[] = "$Id: common.c,v 1.22 2009/05/03 19:32:57 jklowden Exp $";
+static char software_version[] = "$Id: common.c,v 1.23 2010/04/13 13:19:12 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 char USER[512];
@@ -210,7 +212,9 @@ continue_logging_in(CS_CONTEXT ** ctx, CS_CONNECTION ** conn, CS_COMMAND ** cmd,
 {
 	CS_RETCODE ret;
 	char query[30];
+#ifdef TDS_STATIC_CAST
 	TDSCONTEXT *tds_ctx;
+#endif
 
 	ret = cs_ctx_alloc(CS_VERSION_100, ctx);
 	if (ret != CS_SUCCEED) {
@@ -220,12 +224,14 @@ continue_logging_in(CS_CONTEXT ** ctx, CS_CONNECTION ** conn, CS_COMMAND ** cmd,
 		return ret;
 	}
 
+#ifdef TDS_STATIC_CAST
 	/* Force default date format, some tests rely on it */
 	tds_ctx = (TDSCONTEXT *) (*ctx)->tds_ctx;
 	if (tds_ctx && tds_ctx->locale && tds_ctx->locale->date_fmt) {
 		free(tds_ctx->locale->date_fmt);
 		tds_ctx->locale->date_fmt = strdup("%b %d %Y %I:%M%p");
 	}
+#endif
 
 	ret = ct_init(*ctx, CS_VERSION_100);
 	if (ret != CS_SUCCEED) {
diff --git a/src/ctlib/unittests/t0006.c b/src/ctlib/unittests/t0006.c
index 0d98faa..23f5929 100644
--- a/src/ctlib/unittests/t0006.c
+++ b/src/ctlib/unittests/t0006.c
@@ -9,7 +9,7 @@
 #include <stdio.h>
 #include <ctpublic.h>
 
-static char software_version[] = "$Id: t0006.c,v 1.12 2009/12/13 10:36:54 freddy77 Exp $";
+static char software_version[] = "$Id: t0006.c,v 1.13 2010/04/13 13:19:12 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 CS_CONTEXT *ctx;
@@ -91,7 +91,7 @@ DoTest(
 	/* success */
 	return 0;
       Failed:
-	fprintf(stderr, "Test %s failed (ret=%d len=%d)\n", err, retcode, reslen);
+	fprintf(stderr, "Test %s failed (ret=%d len=%d)\n", err, (int) retcode, (int) reslen);
 	fprintf(stderr, "line: %d\n  DO_TEST(%s,\n"
 		"\t   %s,%s,%s,\n"
 		"\t   %s,%s,\n"
@@ -111,7 +111,9 @@ int
 main(int argc, char **argv)
 {
 	CS_RETCODE ret;
+#ifdef tds_sysdep_int64_type
 	volatile tds_sysdep_int64_type one = 1;
+#endif
 	int verbose = 1;
 
 	fprintf(stdout, "%s: Testing conversion\n", __FILE__);
@@ -235,6 +237,7 @@ main(int argc, char **argv)
 		-1230000}
 		, CS_CHAR_TYPE, test, 4, CS_MONEY4_TYPE, sizeof(test2), CS_SUCCEED, &test2, sizeof(test2));
 
+#ifdef tds_sysdep_int64_type
 	DO_TEST(CS_INT test = 1234678;
 		CS_MONEY test2;
 		test2.mnyhigh = ((one * 1234678) * 10000) >> 32;
@@ -245,6 +248,7 @@ main(int argc, char **argv)
 		test2.mnyhigh = ((one * -8765) * 10000) >> 32;
 		test2.mnylow = (CS_UINT) ((one * -8765) * 10000),
 		CS_INT_TYPE, &test, sizeof(test), CS_MONEY_TYPE, sizeof(test2), CS_SUCCEED, &test2, sizeof(test2));
+#endif
 
 	DO_TEST(CS_INT test = 12345;
 		CS_CHAR test2[] = "12345",
@@ -264,6 +268,30 @@ main(int argc, char **argv)
 	DO_TEST(CS_CHAR test[] = " - 12345";
 		CS_INT test2 = -12, CS_CHAR_TYPE, test, 5, CS_INT_TYPE, sizeof(test2), CS_SUCCEED, &test2, sizeof(test2));
 
+	/* to binary */
+	DO_TEST(CS_CHAR test[] = "abc";
+		CS_CHAR test2[] = "abc", CS_BINARY_TYPE, test, 3, CS_BINARY_TYPE, 3, CS_SUCCEED, test2, 3);
+#if 0
+	DO_TEST(CS_CHAR test[] = "abcdef";
+		CS_CHAR test2[] = "ab", CS_BINARY_TYPE, test, 6, CS_BINARY_TYPE, 2, CS_FAIL, test2, 2);
+	DO_TEST(CS_CHAR test[] = "abc";
+		CS_CHAR test2[] = "ab", CS_BINARY_TYPE, test, 3, CS_BINARY_TYPE, 2, CS_FAIL, test2, 2);
+#endif
+	DO_TEST(CS_CHAR test[] = "616263";
+		CS_CHAR test2[] = "abc", CS_CHAR_TYPE, test, 6, CS_BINARY_TYPE, 3, CS_SUCCEED, test2, 3);
+	DO_TEST(CS_CHAR test[] = "616263646566";
+		CS_CHAR test2[] = "abc", CS_CHAR_TYPE, test, 12, CS_BINARY_TYPE, 3, CS_FAIL, test2, 3);
+
+	/* to char */
+	DO_TEST(CS_INT test = 1234567;
+		CS_CHAR test2[] = "1234567", CS_INT_TYPE, &test, sizeof(test), CS_CHAR_TYPE, 7, CS_SUCCEED, test2, 7);
+	DO_TEST(CS_CHAR test[] = "abc";
+		CS_CHAR test2[] = "ab", CS_CHAR_TYPE, test, 3, CS_CHAR_TYPE, 2, CS_FAIL, test2, 2);
+	DO_TEST(CS_CHAR test[] = "abc";
+		CS_CHAR test2[] = "616263", CS_BINARY_TYPE, test, 3, CS_CHAR_TYPE, 6, CS_SUCCEED, test2, 6);
+	DO_TEST(CS_CHAR test[] = "abcdef";
+		CS_CHAR test2[] = "616263", CS_BINARY_TYPE, test, 6, CS_CHAR_TYPE, 6, CS_FAIL, test2, 6);
+
 	ret = cs_ctx_drop(ctx);
 	if (ret != CS_SUCCEED) {
 		fprintf(stderr, "Drop failed\n");

